#include <iostream>
#include <stdlib.h>
#define USE_CONSOLE
#include <allegro.h>

using namespace std;

enum {
  VALGE = -1,
  TYHI = 0,
  MUST = 1
};

enum {
  VALIKUD,
  LOEN_LAUDA,
  MANG,
  VOIT,
  KAOTUS
} olek;

int mangija;


DIALOG othello[] = 
{
//      (dialog proc)     (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)     (d1)                  (d2)  (dp)              (dp2) (dp3)
// #0
      { d_text_proc,      25,  35,   200,  10,   255,  0,    0,    0,          0,                    0,    "OTHELLO",  0,    0},
      { d_text_proc,      25,   120,  200,  10,   255,  0,    0,    0,          0,                    0,    "Kas alustate?",  0,    0},
      { d_radio_proc,     25,   160,  200,  10,   255,  0,    0,    D_SELECTED, 0,                    0,    "&Jah",           0,    0},
      { d_radio_proc,     125,  160,  200,  10,   255,  0,    0,    0,          0,                    0,    "&Ei",            0,    0},
      { d_text_proc,      25,   200,  200,  10,   255,  0,    0,    0,          0,                    0,    "Valge vi must?",   0,    0},
      { d_radio_proc,     25,   240,  200,  10,   255,  0,    0,    D_SELECTED, 1,                    0,    "&Valge",         0,    0},
      { d_radio_proc,     125,  240,  200,  10,   255,  0,    0,    0,          1,                    0,    "&Must",         0,    0},
      { d_button_proc,    25,   360,  150,  32,   255,  0,    0,    D_EXIT,     0,                    0,    "&Uus mng",        0,    0},
      { d_button_proc,    25,   400,  150,  32,   255,  0,    0,    D_EXIT,     0,                    0,    "&Vlju",        0,    0},
      { d_yield_proc,     0,    0,    0,    0,    0,    0,    0,    0,          0,                    0,    0,                0,    0},
      { 0,                0,    0,    0,    0,    0,    0,    0,    0,          0,                    0,    0,                0,    0}
};

DIALOG soovidveel[] = 
{
      { d_button_proc,    25,   360,  150,  32,   255,  0,    0,    D_EXIT,     0,                    0,    "&Alusta uuesti",        0,    0},
      { d_button_proc,    25,   400,  150,  32,   255,  0,    0,    D_EXIT,     0,                    0,    "&Vlju",        0,    0},
      { d_yield_proc,     0,    0,    0,    0,    0,    0,    0,    0,          0,                    0,    0,                0,    0},
      { 0,                0,    0,    0,    0,    0,    0,    0,    0,          0,                    0,    0,                0,    0}
};



class Kaik {
  public:
    int x;
    int y;
    int hinnang;
    Kaik ();
    Kaik (int, int, int);
};

Kaik::Kaik () 
  : x (0)
  , y (0)
  , hinnang (0) 
{}

Kaik::Kaik (int _x, int _y, int _hinnang) 
  : x (_x)
  , y (_y)
  , hinnang (_hinnang) 
{}

class Nimekiri {
  protected:
    Kaik element[30];
    int elemente;
  public:
    Nimekiri ();
    void Lisa (Kaik _k);
    Kaik Vota ();
    Kaik Vaata (int _indeks);
    bool OnTyhi ();
    void Tyhjenda ();
    int Elemente ();
};

Nimekiri::Nimekiri ()
  : elemente (0)
{}

void Nimekiri::Lisa (Kaik _k) {
  int i;
  for (i = 0; i < elemente; i++) {
    if (_k.hinnang > element[i].hinnang) {
      for (int j = elemente; j > i; j--)
        element[j] = element[j - 1];
      break;
    }
  }
  elemente++;
  element[i] = _k;
}

Kaik Nimekiri::Vota () {
  Kaik k;
  k = element[0];
  elemente--;
  for (int i = 0; i < elemente; i++) {
    element[i] = element[i + 1];
  }
  return k;
}

Kaik Nimekiri::Vaata (int _indeks) {
  return element[_indeks];
}

int Nimekiri::Elemente () {
  return elemente;
}

void Nimekiri::Tyhjenda () {
  elemente = 0;
}

class Laud8x8 {
  public:
    char ruut[8][8];
    
    Laud8x8 ();
    bool SaabKaia (int _x, int _y, int _mangija);
    void TeeKaik (int _x, int _y, int _mangija);
    bool LeidubKaik (int _mangija);
    bool OnVoitnud (int _mangija);
    void Tyhjenda ();
    int Hinda (int _mangija);
    Laud8x8* Koopia ();
};

Laud8x8::Laud8x8() {
  Tyhjenda ();
}

void Laud8x8::Tyhjenda () {
  for (int i = 0; i < 8; i++) {
    for (int j = 0; j < 8; j++) {
      ruut[i][j] = TYHI;
    }
  }

  ruut[3][3] = VALGE;
  ruut[4][4] = VALGE;
  ruut[3][4] = MUST;
  ruut[4][3] = MUST;
}

Laud8x8* Laud8x8::Koopia () {
  Laud8x8* l = new Laud8x8 ();
  for (int i = 0; i < 8; i++) {
    for (int j = 0; j < 8; j++) {
      l->ruut[i][j] = ruut[i][j];
    }
  }
  return l;
}

bool Laud8x8::SaabKaia (int _x, int _y, int _mangija) {
  int vastane = _mangija * -1;
  int i;

  if (ruut[_y][_x] != TYHI)
    return false;

  // Vasakule les
  if (_y > 0 && _x > 0 && ruut[_y - 1][_x - 1] == vastane) {
    for (i = 2; (_y - i) >= 0 && (_x - i) >= 0; i++) {
      if (ruut[_y - i][_x - i] == vastane) {
        continue;
      }
      if (ruut[_y - i][_x - i] == _mangija) {
        return true;
      }
      if (ruut[_y - i][_x - i] == TYHI) {
        break;
      }
    }
  }

  // Vasakule
  if (_x > 0 && ruut[_y][_x - 1] == vastane) {
    for (i = 2; (_x - i) >= 0; i++) {
      if (ruut[_y][_x - i] == vastane) {
        continue;
      }
      if (ruut[_y][_x - i] == _mangija) {
        return true;
      }
      if (ruut[_y][_x - i] == TYHI) {
        break;
      }
    }
  }

  // Vasakule alla
  if (_x > 0 && _y < 7 && ruut[_y + 1][_x - 1] == vastane) {
    for (i = 2; (_y + i) <= 7 && (_x - i) >= 0; i++) {
      if (ruut[_y + i][_x - i] == vastane) {
        continue;
      }
      if (ruut[_y + i][_x - i] == _mangija) {
        return true;
      }
      if (ruut[_y + i][_x - i] == TYHI) {
        break;
      }
    }
  }

  // les
  if (_y > 0 && ruut[_y - 1][_x] == vastane) {
    for (i = 2; (_y - i) >= 0; i++) {
      if (ruut[_y - i][_x] == vastane) {
        continue;
      }
      if (ruut[_y - i][_x] == _mangija) {
        return true;
      }
      if (ruut[_y - i][_x] == TYHI) {
        break;
      }
    }
  }

  // Alla
  if (_y < 7 && ruut[_y + 1][_x] == vastane) {
    for (i = 2; (_y + i) <= 7; i++) {
      if (ruut[_y + i][_x] == vastane) {
        continue;
      }
      if (ruut[_y + i][_x] == _mangija) {
        return true;
      }
      if (ruut[_y + i][_x] == TYHI) {
        break;
      }
    }
  }

  // Paremale les
  if (_y > 0 && _x < 7 && ruut[_y - 1][_x + 1] == vastane) {
    for (i = 2; (_y - i) >= 0 && (_x + i) <= 7; i++) {
      if (ruut[_y - i][_x + i] == vastane) {
        continue;
      }
      if (ruut[_y - i][_x + i] == _mangija) {
        return true;
      }
      if (ruut[_y - i][_x + i] == TYHI) {
        break;
      }
    }
  }

  // Paremale
  if (_x < 7 && ruut[_y][_x + 1] == vastane) {
    for (i = 2; (_x - i) <= 7; i++) {
      if (ruut[_y][_x + i] == vastane) {
        continue;
      }
      if (ruut[_y][_x + i] == _mangija) {
        return true;
      }
      if (ruut[_y][_x + i] == TYHI) {
        break;
      }
    }
  }

  // Paremale alla
  if (_x < 7 && _y < 7 && ruut[_y + 1][_x + 1] == vastane) {
    for (i = 2; (_y + i) <= 7 && (_x + i) <= 7; i++) {
      if (ruut[_y + i][_x + i] == vastane) {
        continue;
      }
      if (ruut[_y + i][_x + i] == _mangija) {
        return true;
      }
      if (ruut[_y + i][_x + i] == TYHI) {
        break;
      }
    }
  }

  return false;
}

void Laud8x8::TeeKaik (int _x, int _y, int _mangija) {
  int vastane = _mangija * -1;
  int i, j;

  // Vasakule les
  if (_y > 0 && _x > 0 && ruut[_y - 1][_x - 1] == vastane) {
    for (i = 1; (_y - i) >= 0 && (_x - i) >= 0; i++) {
      if (ruut[_y - i][_x - i] == vastane) {
        continue;
      }
      if (ruut[_y - i][_x - i] == _mangija) {
        for (j = 1; j < i; j++) 
          ruut[_y - j][_x - j] = _mangija;
        break;
      }
      if (ruut[_y - i][_x - i] == TYHI) {
        break;
      }
    }
  }

  // Vasakule
  if (_x > 0 && ruut[_y][_x - 1] == vastane) {
    for (i = 1; (_x - i) >= 0; i++) {
      if (ruut[_y][_x - i] == vastane) {
        continue;
      }
      if (ruut[_y][_x - i] == _mangija) {
        for (j = 1; j < i; j++) 
          ruut[_y][_x - j] = _mangija;
        break;
      }
      if (ruut[_y][_x - i] == TYHI) {
        break;
      }
    }
  }

  // Vasakule alla
  if (_x > 0 && _y < 7 && ruut[_y + 1][_x - 1] == vastane) {
    for (i = 2; (_y + i) <= 7 && (_x - i) >= 0; i++) {
      if (ruut[_y + i][_x - i] == vastane) {
        continue;
      }
      if (ruut[_y + i][_x - i] == _mangija) {
        for (j = 1; j < i; j++) 
          ruut[_y + j][_x - j] = _mangija;
        break;
      }
      if (ruut[_y + i][_x - i] == TYHI) {
        break;
      }
    }
  }

  // les
  if (_y > 0 && ruut[_y - 1][_x] == vastane) {
    for (i = 1; (_y - i) >= 0; i++) {
      if (ruut[_y - i][_x] == vastane) {
        continue;
      }
      if (ruut[_y - i][_x] == _mangija) {
        for (j = 1; j <= i; j++) 
          ruut[_y - j][_x] = _mangija;
        break;
      }
      if (ruut[_y - i][_x] == TYHI) {
        break;
      }
    }
  }

  // Alla
  if (_y < 7 && ruut[_y + 1][_x] == vastane) {
    for (i = 1; (_y + i) <= 7; i++) {
      if (ruut[_y + i][_x] == vastane) {
        continue;
      }
      if (ruut[_y + i][_x] == _mangija) {
        for (j = 1; j < i; j++) 
          ruut[_y + j][_x] = _mangija;
        break;
      }
      if (ruut[_y + i][_x] == TYHI) {
        break;
      }
    }
  }

  // Paremale les
  if (_y > 0 && _x < 7 && ruut[_y - 1][_x + 1] == vastane) {
    for (i = 1; (_y - i) >= 0 && (_x + i) <= 7; i++) {
      if (ruut[_y - i][_x + i] == vastane) {
        continue;
      }
      if (ruut[_y - i][_x + i] == _mangija) {
        for (j = 1; j < i; j++) 
          ruut[_y - j][_x + j] = _mangija;
        break;
      }
      if (ruut[_y - i][_x + i] == TYHI) {
        break;
      }
    }
  }

  // Paremale
  if (_x < 7 && ruut[_y][_x + 1] == vastane) {
    for (i = 1; (_x + i) <= 7; i++) {
      if (ruut[_y][_x + i] == vastane) {
        continue;
      }
      if (ruut[_y][_x + i] == _mangija) {
        for (j = 1; j < i; j++) 
          ruut[_y][_x + j] = _mangija;
        break;
      }
      if (ruut[_y][_x + i] == TYHI) {
        break;
      }
    }
  }

  // Paremale alla
  if (_x < 7 && _y < 7 && ruut[_y + 1][_x + 1] == vastane) {
    for (i = 1; (_y + i) <= 7 && (_x + i) <= 7; i++) {
      if (ruut[_y + i][_x + i] == vastane) {
        continue;
      }
      if (ruut[_y + i][_x + i] == _mangija) {
        for (j = 1; j < i; j++) 
          ruut[_y + j][_x + j] = _mangija;
        break;
      }
      if (ruut[_y + i][_x + i] == TYHI) {
        break;
      }
    }
  }
}

bool Laud8x8::LeidubKaik (int _mangija) {
  for (int i = 0; i < 8; i++) {
    for (int j = 0; j < 8; j++) {
      if (SaabKaia(i,j,_mangija)) {
        return true;
      }
    }
  }
  return false;
}

bool Laud8x8::OnVoitnud (int _mangija) {
  return (Hinda (_mangija) > Hinda (_mangija * -1));
}

int Laud8x8::Hinda (int _mangija) {
  int nuppe = 0;
  for (int i = 0; i < 8; i++) {
    for (int j = 0; j < 8; j++) {
      nuppe += (ruut[i][j] == _mangija);
    }
  }
  return nuppe;
}

void joonista_laud (Laud8x8* _laud) {
  int i, j;
  vsync ();
  scare_mouse ();
  acquire_bitmap (screen);
  rectfill (screen, 210, 50, 610, 450,  makecol (255,255,255));
  textout (screen, font, "OTHELLO", 25, 35, makecol (0,0,0));
  
  for (i = 0; i < 9; i++) {
    line (screen, 210, 50 + i * 50, 610, 50 + i * 50, makecol (0,0,0));
    line (screen, 210 + i * 50, 50, 210 + i * 50, 450, makecol (0,0,0));
  }

  for (i = 0; i < 8; i++) {
    for (j = 0; j < 8; j++) {
      if (_laud->ruut[j][i] == VALGE) {
        circle (screen, 235 + i * 50, 75 + j * 50, 20, makecol (0,0,0));
      } else if (_laud->ruut[j][i] == MUST) {
        circlefill (screen, 235 + i * 50, 75 + j * 50, 20, makecol (0,0,0));
      } else {
        if (_laud->SaabKaia (i,j,mangija)) {
          circle (screen, 235 + i * 50, 75 + j * 50, 5, makecol (0,0,0));
        }
      }
    }
    textprintf (screen, font, 228 + i * 50, 452, makecol (0,0,0), "%c", 'A' + i);
    textprintf (screen, font, 185, 62 + i * 50, makecol (0,0,0), "%d", i + 1);
  }
  release_bitmap (screen);
  unscare_mouse ();
}

void tee_arvuti_kaik (Laud8x8* _laud, int _mangija) {
  Nimekiri kaigud;
  for (int i = 0; i < 8; i++) {
    for (int j = 0; j < 8; j++) {
      if (_laud->SaabKaia (i,j,_mangija)) {
        Laud8x8* uus = _laud->Koopia ();
        Kaik k (i, j, uus->Hinda (_mangija));
        kaigud.Lisa (k);
        delete uus;
      }
    }
  }  
  if (kaigud.Elemente() == 0) {
    if (_laud->LeidubKaik(_mangija * - 1))
      allegro_message ("Mul ei ole kusagile kia! Jtkamiseks vajutage OK");
  } else {
    Kaik tee = kaigud.Vota();
    _laud->ruut[tee.y][tee.x] = _mangija;
    _laud->TeeKaik (tee.x,tee.y,_mangija);
  }
}

void loe_sisend (Laud8x8* _laud, int _mangija) {
  if (mouse_b & 1) {
    for (int i = 0; i < 8; i++) {
      for (int j = 0; j < 8; j++) {
        if (mouse_x > 210 + i * 50 && mouse_x < 260 + i * 50 && mouse_y > 50 + j * 50 && mouse_y < 100 + j * 50) {
          if (_laud->SaabKaia (i, j, _mangija)) {
            _laud->ruut[j][i] = _mangija;
            _laud->TeeKaik (i,j,_mangija);
            joonista_laud (_laud);
            mouse_b = 0;
            rest (1000);
            tee_arvuti_kaik (_laud, _mangija * -1);
            return;
          }
        }
      } 
    }
  }  
}

int main(int argc, char *argv[])
{
  Laud8x8 laud;

  srand(time(0));
  set_uformat(U_ASCII);

  allegro_init ();
  set_window_title ("Othello");
  if (desktop_color_depth () == 32)
    set_color_depth (32);
  if (desktop_color_depth () == 16)
    set_color_depth (16);
  if (set_gfx_mode (GFX_AUTODETECT_WINDOWED, 640, 480, 640, 480) < 0) {
    if (set_gfx_mode (GFX_AUTODETECT, 640, 480, 640, 480) < 0) {
      allegro_message ("Pilti nidata ei nnestunud!");
    }
  }
  install_keyboard ();
  install_mouse ();

  clear_to_color (screen, makecol (255,255,255));
  show_mouse (screen);

  for (int ret = 0; othello[ret].proc; ret++) {
    othello[ret].bg = makecol(255, 255, 255);
    othello[ret].fg = makecol(0, 0, 0);
  }
  for (ret = 0; soovidveel[ret].proc; ret++) {
    soovidveel[ret].bg = makecol(255, 255, 255);
    soovidveel[ret].fg = makecol(0, 0, 0);
  }

  DATAFILE* andmed = load_datafile ("#");
  font = (FONT*)(andmed[0]).dat;
  text_mode (makecol (255,255,255));
  
  olek = VALIKUD;
  bool mulkaik, sulkaik;

  while (1) {
    if (olek == VALIKUD) {
      int signal = do_dialog (othello, 0);
      if (signal == 10)
        exit (0);
  
      if (othello[5].flags == D_SELECTED)
        mangija = VALGE;
      if (othello[6].flags == D_SELECTED)
        mangija = MUST;

      laud.Tyhjenda ();

      if (othello[3].flags == D_SELECTED) {
        tee_arvuti_kaik (&laud, (mangija * -1));
      }

      
      scare_mouse ();
      clear_to_color (screen, makecol (255, 255,255));
      unscare_mouse ();
      olek = MANG;
    }

    if (olek == MANG) {
      joonista_laud (&laud);
      mulkaik = laud.LeidubKaik(mangija);    
      sulkaik = laud.LeidubKaik(mangija * -1);
      if (!mulkaik) {
        if (!sulkaik) {
          if (laud.OnVoitnud (mangija)) {
            allegro_message ("Teie vit!!!");
            olek = VOIT;
          } else {
            allegro_message ("Minu vit!");
            olek = KAOTUS;
          }
        } else {
          allegro_message ("Teil ei ole htegi kiku! Jtkamiseks vajutage OK");
          rest (1000);
          tee_arvuti_kaik (&laud, mangija * -1);
        }
      } else {
        loe_sisend (&laud, mangija);
      }
      rest (50);
      yield_timeslice ();
      if (keypressed ()) {
        if (readkey () >> 8 == KEY_ESC)
          break;
      }
          
    }

    if (olek == VOIT || olek == KAOTUS) {
      joonista_laud (&laud);
      int signal = do_dialog (soovidveel, 0);
      if (signal == 1)
        exit (0);
      clear_to_color (screen, makecol (255, 255,255));
      olek = VALIKUD;
      laud.Tyhjenda ();
      yield_timeslice ();
    }

  }
 
  return 0;
}
