// Tehisintellekt I 3. kodut
// Seitsme-mng
// Dan Bogdanov, inf III


#include <iostream>
#define USE_CONSOLE
#include <allegro.h>

using namespace std;

enum {
  OLEK_ALUSTAMINE,
  OLEK_LAUA_LUGEMINE,
  OLEK_LAHENDAMINE,
  OLEK_LAHENDATUD
};

enum {
    RUUT_TYHI,
    RUUT_MUST,
    RUUT_VALGE
};

enum {
    PROD_LIIKUJA = 0,
    PROD_SAMME = 1,
    PROD_SIHT = 2
};

static int prod[20][3] = {
    {RUUT_MUST, 1, RUUT_TYHI},
    {RUUT_MUST, 2, RUUT_TYHI},
    {RUUT_MUST, 3, RUUT_TYHI},
    {RUUT_VALGE, -1, RUUT_TYHI},
    {RUUT_VALGE, -2, RUUT_TYHI},
    {RUUT_VALGE, -3, RUUT_TYHI},
};
int produktsioone = 6;

DIALOG nupud[] = 
{
      { d_button_proc,    25,   360,  150,  32,   255,  0,    0,    D_EXIT,     0,                    0,    "&Uus mng",        0,    0},
      { d_button_proc,    25,   400,  150,  32,   255,  0,    0,    D_EXIT,     0,                    0,    "&Lpeta",        0,    0},
      { d_yield_proc,     0,    0,    0,    0,    0,    0,    0,    0,          0,                    0,    0,                0,    0},
      { 0,                0,    0,    0,    0,    0,    0,    0,    0,          0,                    0,    0,                0,    0}
};



class SeitseLaud {
public:
  int ruut[7];

  SeitseLaud () {
    Tyhjenda ();
  }

  void Tyhjenda () {
    for (int i = 0; i < 7; i++)
      ruut[i] = 0;
  }

  bool OnLopp () {
      int valgeid = 0;
      for (int i = 0; i < 4; i++) {
          if (ruut[i] == RUUT_VALGE)
              valgeid++;
          if (valgeid == 3)
              return true;
          if (ruut[i] == RUUT_MUST)
              return false;
      }
      return false;
  }

  void Kopeeri (SeitseLaud* _laud) {
      for (int i = 0; i < 7; i++) {
          ruut[i] = _laud->ruut[i];
      }
  }

  void Rakenda (int _i, int _p) {
      ruut[_i] = prod[_p][PROD_SIHT]; 
      ruut[_i + prod[_p][PROD_SAMME]] = prod[_p][PROD_LIIKUJA];
  }

  void Tryki () {
    printf ("%d %d %d %d %d %d %d\n", ruut[0], ruut[1], ruut[2], ruut[3], ruut[4], ruut[5], ruut[6]);
  }
};

class KaheTaisarvuMagasin {
    int arv1[50];
    int arv2[50];
    int arve;

public:    
    KaheTaisarvuMagasin () {
         arve = 0;
    }

    
    void Lisa (int _arv1, int _arv2) {
        if (arve >= 50)
            return;

        arv1[arve] = _arv1;
        arv2[arve] = _arv2;
        arve++;
    }
    
    void Vota (int* _arv1, int* _arv2) {
        if (arve <= 0)
            return;
        arve--;
        *_arv1 = arv1[arve];
        *_arv2 = arv2[arve];
    }    

    void Tyhjenda () {
      arve = 0;
    }
    
    bool OnTyhi () {
        return (arve == 0);
    }
} magasin;

int seniparim = INT_MAX;
int sygavus = 0;
int olek = OLEK_ALUSTAMINE;
int lisatavnumber = 0;
int valget = 0;
int musta = 0;

bool parimkaik (SeitseLaud* _laud) {
    SeitseLaud test;
    int i, j;
    if (_laud->OnLopp()) {
        if (sygavus < seniparim) {
            magasin.Tyhjenda ();
            seniparim = sygavus;
            return true;
        }
        return false;
    }
    bool leidublopuni = false;
    
    sygavus++;
    for (i = 0; i < 7; i++) {
        for (j = 0; j < produktsioone; j++) {
            if (_laud->ruut[i] == prod[j][PROD_LIIKUJA] && (i + prod[j][PROD_SAMME]) >= 0 && (i + prod[j][PROD_SAMME]) < 7 && _laud->ruut[i + prod[j][PROD_SAMME]] == prod[j][PROD_SIHT]) {
                test.Kopeeri(_laud);
                test.Rakenda (i,j);
                if (parimkaik (&test)) {
                    leidublopuni = true;
                    magasin.Lisa (i, j);
                }
            }
        }
    }
    sygavus--;
    
    return leidublopuni; 
}

void lahenda (SeitseLaud* _laud) {
  parimkaik (_laud);
}

void loe_hiirt (SeitseLaud* _laud) {

  if (mouse_b & 1 || mouse_b & 2) {
    if (olek == OLEK_LAUA_LUGEMINE) {
      for (int i = 0; i < 7; i++) {
        if ((mouse_x > 210 + i * 52) && (mouse_x < 250 + i * 60) && mouse_y > 210 && mouse_y < 250) {
          if (_laud->ruut[i] == 0) {
            if (mouse_b & 1) {
              if (valget < 3) {
                _laud->ruut[i] = RUUT_VALGE;
                valget++;
              }
            } else if (mouse_b & 2) {
              if (musta < 3) {
                _laud->ruut[i] = RUUT_MUST;
                musta++;
              }
            }
            if (valget == 3 && musta == 3) {
              valget = 0;
              musta = 0;
              olek = OLEK_LAHENDAMINE;
              break;
            }
          }
        }
      }
    }
  }
  mouse_b = 0;
}

void joonista_ruut (int _number, int _x, int _y = 200) {
  if (_number == RUUT_MUST) {
    circlefill (screen, 240 + _x * 52, 230, 20,makecol (0,0,0));
    return;
  }
  if (_number == RUUT_VALGE) {
    circle (screen, 240 + _x * 52, 230, 20,makecol (0,0,0));
    return;
  }
  circlefill (screen, 240 + _x * 52, 230, 22,makecol (255,255,255));
}

void joonista_laud (SeitseLaud* _laud) {  
  vsync ();
  scare_mouse ();
  acquire_bitmap (screen);
  textout (screen, font, "-=# SEITSE #=-", 25, 35, makecol (0,0,0));
  rectfill (screen, 210, 200, 215, 260, makecol (0,0,0));
  rectfill (screen, 577, 200, 582, 260, makecol (0,0,0));
  rectfill (screen, 210, 200, 582, 205, makecol (0,0,0));
  rectfill (screen, 210, 255, 582, 260, makecol (0,0,0));
  
  for (int i = 0; i < 8; i++) {
    if (i < 6)
      rectfill (screen, 265 + i * 52, 200, 267 + i * 52, 260, makecol (0,0,0));    
    joonista_ruut (_laud->ruut[i], i); 
  }
  rectfill (screen, 220, 400, 640, 480, makecol (255, 255, 255));
  if (olek == OLEK_LAUA_LUGEMINE) {
    textprintf (screen, font, 220, 400, makecol (0, 0, 0), "Vasak nupp - valge, parem nupp - must.");
  }
  if (olek == OLEK_LAHENDAMINE) {
    textprintf (screen, font, 250, 400, makecol (0, 0, 0), "Lahendan.");
  }
  if (olek == OLEK_LAHENDATUD) {
    textprintf (screen, font, 250, 400, makecol (0, 0, 0), "Lahendatud!.");
  }
  release_bitmap (screen);
  unscare_mouse ();
}

int main() {
  srand(time(0));
  set_uformat(U_ASCII);

  allegro_init ();
  set_window_title ("Viieteistkmnemng!");
  if (desktop_color_depth () == 32)
    set_color_depth (32);
  if (desktop_color_depth () == 16)
    set_color_depth (16);
  if (set_gfx_mode (GFX_AUTODETECT_WINDOWED, 640, 480, 640, 480) < 0) {
    if (set_gfx_mode (GFX_AUTODETECT, 640, 480, 640, 480) < 0) {
      allegro_message ("Pilti nidata ei nnestunud!");
    }
  }
  install_keyboard ();
  install_mouse ();

  clear_to_color (screen, makecol (255,255,255));
  show_mouse (screen);

  DATAFILE* andmed = load_datafile ("#");
  font = (FONT*)(andmed[0]).dat;
  text_mode (makecol (255,255,255));

  SeitseLaud laud;
  laud.Tyhjenda ();

  for (int ret = 0; nupud[ret].proc; ret++) {
    nupud[ret].bg = makecol(255, 255, 255);
    nupud[ret].fg = makecol(0, 0, 0);
  }

  while (1) {
    clear_keybuf ();
    joonista_laud (&laud);
    int signal = do_dialog (nupud, 0);
    if (signal == 1)
      exit (0);

    laud.Tyhjenda ();
 
    olek = OLEK_LAUA_LUGEMINE;
    while (olek == OLEK_LAUA_LUGEMINE) {
      joonista_laud (&laud);
      loe_hiirt (&laud);
      rest (50);
      yield_timeslice ();
    }

    olek = OLEK_LAHENDAMINE;
    lahenda (&laud);

    int p, r;
    while (!magasin.OnTyhi ()) {
      rest (1500);
      yield_timeslice ();
      magasin.Vota (&p, &r);
      laud.Rakenda (p,r);
      joonista_laud (&laud);
    }

    olek = OLEK_LAHENDATUD;

  }
  return 0;
}

